Reference Manual

Main Page | Namespace List | Class Hierarchy | Alphabetical List | Compound List | File List | Namespace Members | Compound Members | File Members

# Inti::Gtk::Fixed Class Reference

A GtkFixed C++ wrapper class. More...

`#include <inti/gtk/fixed.h>`

Inheritance diagram for Inti::Gtk::Fixed:

List of all members.

## Public Member Functions

Constructors

- Fixed ()
    Construct a new Fixed container.
- virtual ~Fixed ()
    Destructor.

Accessors

- GtkFixed * gtk_fixed () const
    Get a pointer to the GtkFixed structure.
- GtkFixedClass * gtk_fixed_class () const
    Get a pointer to the GtkFixedClass structure.
- operator GtkFixed * () const
    Conversion operator; safely converts a Fixed to a GtkFixed pointer.

Methods

- void put (Widget &widget, int x, int y)
    Adds a widget to a Fixed container at the given position.
- void move (Widget &widget, int x, int y)
    Moves a child of a Fixed container to the given position.
- void set_has_window (bool has_window)
    Sets whether a Fixed widget is created with a separate Gdk::Window or not.

Child Property Proxies

- const XPropertyProxy prop_x ()
    X position of the child widget (int : Read / Write).
- const YPropertyProxy prop_y ()
    Y position of the child widget (int : Read / Write).

## Protected Member Functions

Constructors

- Fixed (GtkFixed *fixed, bool reference=false)
    Construct a new Fixed from an existing GtkFixed.

## Detailed Description

A GtkFixed C++ wrapper class.

The Fixed widget is a container which can place child widgets at fixed positions and with fixed sizes, given in pixels. Fixed performs no automatic layout management. For most applications, you should not use this container! It keeps you from having to learn about the other containers, and it results in broken applications. With Fixed, the following things will result in truncated text, overlapping widgets, and other display bugs:

- Themes, which may change widget sizes.

- Fonts other than the one you used to write the app will of course change the size of widgets containing text; keep in mind that users may use a larger font because of difficulty reading the default, or they may be using Windows or the framebuffer port of GTK+, where different fonts are available.

- Translation of text into other languages changes its size. Also, display of non-English text will use a different font in many cases.

- In addition, the fixed widget can't properly be mirrored in right-to-left languages such as Hebrew and Arabic. i.e. normally GTK+ will flip the interface to put labels to the right of the thing they label, but it can't do that with Fixed. So your application will not be usable in right-to-left languages.

- Finally, fixed positioning makes it kind of annoying to add/remove GUI elements, since you have to reposition all the other elements. This is a long-term maintenance problem for your application.

If you know none of these things are an issue for your application, and prefer the simplicity of Fixed, by all means use the widget. But you should be aware of the tradeoffs.

## Constructor & Destructor Documentation

Inti::Gtk::Fixed::Fixed | ( | GtkFixed * | fixed,
|  | bool | reference = false
| ) | `[explicit, protected]`

  | Construct a new Fixed from an existing GtkFixed. Parameters:
  fixed | A pointer to a GtkFixed.
  reference | Set false if the initial reference count is floating, set true if it's not.
The fixed can be a newly created GtkFixed or an existing GtkFixed (see G::Object::Object).

## Member Function Documentation

void Inti::Gtk::Fixed::move | ( | Widget & | widget,
|  | int | x,
|  | int | y
| ) |

  | Moves a child of a Fixed container to the given position. Parameters:
  widget | The child widget.
  x | The horizontal position to move the widget to.
  y | The vertical position to move the widget to.

void Inti::Gtk::Fixed::put | ( | Widget & | widget,
|  | int | x,
|  | int | y
| ) |

  | Adds a widget to a Fixed container at the given position. Parameters:
  widget | The widget to add.
  x | The horizontal position to place the widget at.
  y | The vertical position to place the widget at.

void Inti::Gtk::Fixed::set_has_window | ( | bool | has_window | ) |

  | Sets whether a Fixed widget is created with a separate Gdk::Window or not. Parameters:
  has_window | true if a separate window should be created.
By default, Fixed will be created with no separate Gdk::Window. This method must be called while the Fixed is not realized, for instance, immediately after the window is created.

The documentation for this class was generated from the following file:

- fixed.h

Main Page - Footer